C**************************************************************
C      HAPEM4 Model Post processing Program 
C**************************************************************
c	program EXPO-A (for exposure calculation only 
c                      these include background, not risk)
C
C***	This is the first program to take each demographic group and 
c***    determine the median and 90th percentile exposures by census tract
C***	DEVELOPED 6/14/00 Ted Palma - USEPA
c***	modifed 7/12/00 t.p. split program for exposure and risk, risk will
c							remove background;  also
c							determine SC contribution on average
c		sorting routine from Leonard J. Moss of SLAC (off Internet)
C***

	CHARACTER*80 NAME
	REAL  X(30), popp(54)
	real*8 xmed(54,6), p90(54,6),summed, avg, data(30),CONC(6,30)
	integer indexx(30)
C
      IRD=20
      IWRI=21


 9999   FORMAT(A30)

        OPEN(UNIT=ird,file="INPUT.DAT",STATUS='old')
	  OPEN(UNIT=iwri,file="LADD.OUT",STATUS='UNKNOWN')

c	read header line at top of file
	read(ird,9999)name(1:1)	
	ierr=0

	do while(ierr.EQ.0)  !read entire file (all census tracts)

	Do IX=1,40    ! this is one census tract

	J=1
	DO WHILE (j.LT.31)
	READ(ird,*,END=999,IOSTAT=IERR)
	1	i1,i2,i3,i4,pop,(conc(i,j),i=1,6)

	J=J+1
	JMAX=J
	END DO

	if(pop.eq.0)then    !check for populations of zero
		do ii=1,6
		 xmed(i4,ii)=0.0
		 enddo
		
		popp(i4)=pop*30.0   !save population for this demo group


	else					!if population greater than zero do calcs

	N=30
	DO I=1,30
	X(I)=CONC(6,I)*1000.
	END DO
      call SORTRX(N,x,INDEXx)

c	do median calcualtions for category 6
c	source categories: point(1), area(2), onroad-mobile(3)	
c                        off-mobile(4), background(5), total(6)


	xmed(i4,6)= (conc(6,indexx(15))+conc(6,indexx(16)))/2.0

	N=30

	do ii=1,5
		DO I=1,30
			data(I)=CONC(ii,I)
		END DO
      call average(N,data,AVG)
	xmed(i4,ii)=AVG   !this is not really the median it is the avg
	end do !II


c	adjust SC contributions to equal totals (6) by avg 7/12

	summed=xmed(i4,1)+xmed(i4,2)+xmed(i4,3)+xmed(i4,4)+xmed(i4,5)
	do ii=1,5

	if(summed.gt.0)then
	 xmed(i4,ii)=xmed(i4,6)*(xmed(i4,ii)/summed)
	else
	 xmed(i4,ii)=0.0
	end if

	end do
c	end of adjustment 7/12




c end modifcation 7/12

	popp(i4)=pop*30.0   !save population for this demo group
	endif   !!!pop > zero if	

	end do !!!!!(IX) one census tract

c	sum demogropus for this tract and weigh by population

c	Age 0-5   :#30 groups 1,2,3,4,26,27,28,29	
c	Age 6-11  :#35 groups 6,7,8,9,31,32,33,34
c	Age 12-17 :#40 groups 11,12,13,14,36,37,38,39
c	Age 18-64 :#45 groups 16,17,18,19,41,42,43,44
c	Age 65+   :#50 groups 21,22,23,24,46,47,48,49
	
	do iz=0,20,5	!group loop

	do ii = 1,6  !loop for SC
	
	popp(30+iz) =    popp(1+iz) + 
     2	             popp(2+iz) +
     2	             popp(3+iz) +
     2	             popp(4+iz) +
     2	             popp(26+iz)+
     2	             popp(27+iz)+
     2	             popp(28+iz)+
     2	             popp(29+iz)
	
	IF(popp(30+iz).gt.0)then
		xmed(30+iz,ii) = (popp(1+iz)* xmed(1+iz,ii) + 
     2	             popp(2+iz)* xmed(2+iz,ii) +
     2	             popp(3+iz)* xmed(3+iz,ii) +
     2	             popp(4+iz)* xmed(4+iz,ii) +
     2	             popp(26+iz)* xmed(26+iz,ii) +
     2	             popp(27+iz)* xmed(27+iz,ii) +
     2	             popp(28+iz)* xmed(28+iz,ii) +
     2	             popp(29+iz)* xmed(29+iz,ii))/popp(30+iz)

	else

		xmed(30+iz,ii) = 0.0

	end if !zero pop

	end do			!end SC loop
c	write Age grouped sub population median and 90th%
		 
c dont write indivual ages:
c	write(21,"(2x,i2.2,2x,i3.3,2x,i6.6,2x,i2.2,2x,
c	1  F10.0,12(1pe14.7,1x))")
c	1  i1,i2,i3,30+iz,popp(30+iz),(Xmed(30+iz,ii),ii=1,6),
c     1  (p90(30+iz,ii),ii=1,6)

	end do			!group (iz) loop

c	now total the population avgerage for census tract
c	Total Population   :#51 groups 30,35,40,45,50
c		Age 0-11  pop group #52
c		Age 12-plus pop group #53



		popp(51)= popp(30)+ popp(35)+ popp(40)+ popp(45)+ popp(50)
		popp(52)= popp(30)+ popp(35)
		popp(53)= popp(40)+ popp(45)+ popp(50)

	do ii = 1,6  !loop for SC

		IF(popp(51).gt.0)then
		xmed(51,ii) = (popp(30)* xmed(30,ii) + 
     2	             popp(35)* xmed(35,ii) +
     2	             popp(40)* xmed(40,ii) +
     2	             popp(45)* xmed(45,ii) +
     2	             popp(50)* xmed(50,ii))/popp(51)

		else

		xmed(51,ii) = 0.0

	end if !zero pop


		IF(popp(52).gt.0)then
		xmed(52,ii) = (popp(30)* xmed(30,ii) + 
     2	             popp(35)* xmed(35,ii))/popp(52)

		else

		xmed(52,ii) = 0.0

	end if !zero pop

		IF(popp(53).gt.0)then
		xmed(53,ii) = (popp(40)* xmed(40,ii) +
     2	             popp(45)* xmed(45,ii) +
     2	             popp(50)* xmed(50,ii))/popp(53)

		else

		xmed(53,ii) = 0.0

	end if !zero pop


		end do !SC LOOP

c	write kids/adults only population median 
		 

	write(21,"(2x,i2.2,2x,i3.3,2x,i6.6,2x,'52',2x,
	1  F10.0,6(1pe14.7,1x),2x,'53',2x,0pF10.0,6(1pe14.7,1x))")
	1  i1,i2,i3,popp(52),(Xmed(52,ii),ii=1,6),
     1  popp(53),(Xmed(53,ii),ii=1,6)


	END DO ! WHOLE FILE DO LOOP

999	STOP
	end	



C From Leonard J. Moss of SLAC:

C Here's a hybrid QuickSort I wrote a number of years ago.  It's
C based on suggestions in Knuth, Volume 3, and performs much better
C than a pure QuickSort on short or partially ordered input arrays.  


      SUBROUTINE SORTRX(N,DATA,INDEXX)
C===================================================================
C
C     SORTRX -- SORT, Real input, indeX output
C
C
C     Input:  N     INTEGER
C             DATA  REAL
C
C     Output: INDEXX INTEGER (DIMENSION N)
C
C This routine performs an in-memory sort of the first N elements of
C array DATA, returning into array INDEX the indices of elements of
C DATA arranged in ascending order.  Thus,
C
C    DATA(indexx(1)) will be the smallest number in array DATA;
C    DATA(indexx(N)) will be the largest number in DATA.
C
C The original data is not physically rearranged.  The original order
C of equal input values is not necessarily preserved.
C
C===================================================================
C
C SORTRX uses a hybrid QuickSort algorithm, based on several
C suggestions in Knuth, Volume 3, Section 5.2.2.  In particular, the
C "pivot key" [my term] for dividing each subsequence is chosen to be
C the median of the first, last, and middle values of the subsequence;
C and the QuickSort is cut off when a subsequence has 9 or fewer
C elements, and a straight insertion sort of the entire array is done
C at the end.  The result is comparable to a pure insertion sort for
C very short arrays, and very fast for very large arrays (of order 12
C micro-sec/element on the 3081K for arrays of 10K elements).  It is
C also not subject to the poor performance of the pure QuickSort on
C partially ordered data.
C
C Created:  15 Jul 1986  Len Moss
C
C===================================================================
 
      INTEGER   N,indexx(N)
      REAL      DATA(N)
 
      INTEGER   LSTK(31),RSTK(31),ISTK
      INTEGER   L,R,I,J,P,INDEXP,INDEXT
      REAL      DATAP
 
C     QuickSort Cutoff
C
C     Quit QuickSort-ing when a subsequence contains M or fewer
C     elements and finish off at end with straight insertion sort.
C     According to Knuth, V.3, the optimum value of M is around 9.
 
      INTEGER   M
      PARAMETER (M=9)
 
C===================================================================
C
C     Make initial guess for INDEXX
 
      DO 50 I=1,N
         indexx(I)=I
   50    CONTINUE
 
C     If array is short, skip QuickSort and go directly to
C     the straight insertion sort.
 
      IF (N.LE.M) GOTO 900
 
C===================================================================
C
C     QuickSort
C
C     The "Qn:"s correspond roughly to steps in Algorithm Q,
C     Knuth, V.3, PP.116-117, modified to select the median
C     of the first, last, and middle elements as the "pivot
C     key" (in Knuth's notation, "K").  Also modified to leave
C     data in place and produce an INDEX array.  To simplify
C     comments, let DATA[I]=DATA(indexx(I)).
 
C Q1: Initialize
      ISTK=0
      L=1
      R=N
 
  200 CONTINUE
 
C Q2: Sort the subsequence DATA[L]..DATA[R].
C
C     At this point, DATA[l] <= DATA[m] <= DATA[r] for all l < L,
C     r > R, and L <= m <= R.  (First time through, there is no
C     DATA for l < L or r > R.)
 
      I=L
      J=R
 
C Q2.5: Select pivot key
C
C     Let the pivot, P, be the midpoint of this subsequence,
C     P=(L+R)/2; then rearrange indexx(L), indexx(P), and indexx(R)
C     so the corresponding DATA values are in increasing order.
C     The pivot key, DATAP, is then DATA[P].
 
      P=(L+R)/2
      INDEXP=indexx(P)
      DATAP=DATA(INDEXP)
 
      IF (DATA(indexx(L)) .GT. DATAP) THEN
         indexx(P)=indexx(L)
         indexx(L)=INDEXP
         INDEXP=indexx(P)
         DATAP=DATA(INDEXP)
      ENDIF
 
      IF (DATAP .GT. DATA(indexx(R))) THEN
         IF (DATA(indexx(L)) .GT. DATA(indexx(R))) THEN
            indexx(P)=indexx(L)
            indexx(L)=indexx(R)
         ELSE
            indexx(P)=indexx(R)
         ENDIF
         indexx(R)=INDEXP
         INDEXP=indexx(P)
         DATAP=DATA(INDEXP)
      ENDIF
 
C     Now we swap values between the right and left sides and/or
C     move DATAP until all smaller values are on the left and all
C     larger values are on the right.  Neither the left or right
C     side will be internally ordered yet; however, DATAP will be
C     in its final position.
 
  300 CONTINUE
 
C Q3: Search for datum on left >= DATAP
C
C     At this point, DATA[L] <= DATAP.  We can therefore start scanning
C     up from L, looking for a value >= DATAP (this scan is guaranteed
C     to terminate since we initially placed DATAP near the middle of
C     the subsequence).
 
         I=I+1
         IF (DATA(indexx(I)).LT.DATAP) GOTO 300
 
  400 CONTINUE
 
C Q4: Search for datum on right <= DATAP
C
C     At this point, DATA[R] >= DATAP.  We can therefore start scanning
C     down from R, looking for a value <= DATAP (this scan is guaranteed
C     to terminate since we initially placed DATAP near the middle of
C     the subsequence).
 
         J=J-1
         IF (DATA(indexx(J)).GT.DATAP) GOTO 400
 
C Q5: Have the two scans collided?
 
      IF (I.LT.J) THEN
 
C Q6: No, interchange DATA[I] <--> DATA[J] and continue
 
         INDEXT=indexx(I)
         indexx(I)=indexx(J)
         indexx(J)=INDEXT
         GOTO 300
      ELSE
 
C Q7: Yes, select next subsequence to sort
C
C     At this point, I >= J and DATA[l] <= DATA[I] == DATAP <= DATA[r],
C     for all L <= l < I and J < r <= R.  If both subsequences are
C     more than M elements long, push the longer one on the stack and
C     go back to QuickSort the shorter; if only one is more than M
C     elements long, go back and QuickSort it; otherwise, pop a
C     subsequence off the stack and QuickSort it.
 
         IF (R-J .GE. I-L .AND. I-L .GT. M) THEN
            ISTK=ISTK+1
            LSTK(ISTK)=J+1
            RSTK(ISTK)=R
            R=I-1
         ELSE IF (I-L .GT. R-J .AND. R-J .GT. M) THEN
            ISTK=ISTK+1
            LSTK(ISTK)=L
            RSTK(ISTK)=I-1
            L=J+1
         ELSE IF (R-J .GT. M) THEN
            L=J+1
         ELSE IF (I-L .GT. M) THEN
            R=I-1
         ELSE
C Q8: Pop the stack, or terminate QuickSort if empty
            IF (ISTK.LT.1) GOTO 900
            L=LSTK(ISTK)
            R=RSTK(ISTK)
            ISTK=ISTK-1
         ENDIF
         GOTO 200
      ENDIF
 
  900 CONTINUE
 
C===================================================================
C
C Q9: Straight Insertion sort
 
      DO 950 I=2,N
         IF (DATA(indexx(I-1)) .GT. DATA(indexx(I))) THEN
            INDEXP=indexx(I)
            DATAP=DATA(INDEXP)
            P=I-1
  920       CONTINUE
               indexx(P+1) = indexx(P)
               P=P-1
               IF (P.GT.0) THEN
                  IF (DATA(indexx(P)).GT.DATAP) GOTO 920
               ENDIF
            indexx(P+1) = INDEXP
         ENDIF
  950    CONTINUE
 
C===================================================================
C
C     All done
 
      END


C From Leonard J. Moss of SLAC:

C Here's a hybrid QuickSort I wrote a number of years ago.  It's
C based on suggestions in Knuth, Volume 3, and performs much better
C than a pure QuickSort on short or partially ordered input arrays.  


      SUBROUTINE AVERAGE(N,DATA,AVG)
C===================================================================
C
C
C     Input:  N     INTEGER
C             DATA  REAL
C
C     Output: AVG REAL
C
C
C Created:  12 Jul 2000  Ted Palma
C
C===================================================================
 
   
      INTEGER   N
      REAL*8      DATA(N)
	real*8		avg, sum
 
	sum=0.0


	sum=data(1)+data(2)+data(3)+
     1    data(4)+data(5)+data(6)+
     1    data(7)+data(8)+data(9)+
     1    data(10)+data(11)+data(12)+
     1    data(13)+data(14)+data(15)+
     1    data(16)+data(17)+data(18)+
     1    data(19)+data(20)+data(21)+
     1    data(22)+data(23)+data(24)+
     1    data(25)+data(26)+data(27)+
     1    data(28)+data(29)+data(30)
	
	
	 avg=sum/float(n)

	end
