C**************************************************************
C      HAPEM4 Model Post processing Program expo3su
C**************************************************************
C
C***	This is the 3rd program to take each preprocessed file ADD 
c     and determine  the median, 5th to the 95th percentile and create 
c     a file of state level ranges for a single pollutant.
C***	DEVELOPED 7/5/00 Ted Palma - USEPA
c		modified 7/19/00 for revised state from county
 
c	Input data: ADD-ALL.out - file from EXPO2 as input
c				STATES.FIPS - listing of states and FIPS codes
c				COUNTY.TXT - listing of county and FIPS codes
c				INDEX.TXT   - listing of pollutants

c	Output:     EXPO-ADD-ALL-SU.out - a pollutant specific exposure
c				   concentration file summaried for each urban county.
c
C***
	CHARACTER*1 Dummy,UR(6000)
	CHARACTER*5 APOLNUM,APOLNUM2
	CHARACTER*9 CAS
	CHARACTER*80 NAME
	CHARACTER*20 statename(99),countyname(7000)
	CHARACTER*24 polname

	REAL X(7000), xmed(2,6),p90(2,6),pop(2), xmedcounty(7000,2,6),
	1			 xpopcounty(2),county(6,2), county25(6,2),
     1             county75(6,2),county5(6,2),county10(6,2),
	1	          countya(6,2),county90(6,2),county95(6,2),
	1				popt(7000,2)
  
	integer    indexx(7000),idc(7000)



C


C
      IRD1=18
	IRD2=19
	IRD3=20
	IRD4 =21
      IWRI1=22
c	iwri2=23

c	OPEN(UNIT=iwri2,file='run.log',STATUS='unknown')

c	Open Master County FIPS List:
	OPEN(UNIT=ird2,file='county.txt',STATUS='old')
	is=1
	read (ird2,'(i5,4x,1a1,4x,a20)',iostat=ierr)
	1             idc(is),UR(is),countyname(is)
	do while (ierr.eq.0)
	 is=is+1
	read (ird2,'(i5,4x,1a1,4x,a20)',iostat=ierr)
	1             idc(is),UR(is),countyname(is)

c	 write(iwri2, '(x,i5.5,4x,i5.5,8x,a20)')is,idc(is),countyname(is)
	end do

	 idctotal=is-1
c	write(iwri2, '(x,i5.5)')idctotal
	
c	Open Master State FIPS List:
	OPEN(UNIT=ird3,file='states.fips',STATUS='old')
	read (ird3,'(7x,i2,8x,a20)',iostat=ierr)is,statename(is)
	do while (ierr.eq.0)
	 read (ird3,'(7x,i2,8x,a20)',iostat=ierr)is,statename(is)
	end do
	

 9999   FORMAT(A)

	write(6,'(a,$)')" Enter Pollutant SAROD#: "
	read(5,*)APOLNUM(1:5)


c	Open Master Pollutant List:
	OPEN(UNIT=ird3,file='index.txt',STATUS='old')

	read (IRD3, 9999) DUMMY(1:1) ! read header line
	read (IRD3, 666, iostat=ierr) 
	1		APOLNUM2 ,CAS, polname(1:24)   ! read first pollutant
	do while (ierr.eq.0)
	IF(APOLNUM.EQ.APOLNUM2)GO TO 11
	read (IRD3, 666, iostat=ierr) 
	1		APOLNUM2 ,CAS, polname(1:24)   ! read NEXT pollutant
	end do


 666	format(16X,1A5,3x,1A9,1a24)

c	These are the combined output files from expo2:
11			 NAME=".\"//APOLNUM(1:5)//"\"//"ADD-ALL.OUT"
			 OPEN(UNIT=ird1,file=NAME,STATUS='old')


c	These are the exposure output files by state urban only:
			 NAME=".\"//APOLNUM(1:5)//"\"//"EXPO-ADD-ALL-SU.OUT"
			 OPEN(UNIT=iwri1,file=NAME,STATUS='unknown')


 124		READ (ird1, *,iostat=ierr1) i1,i2,i3,i4,pop(1),
	1   (Xmed(1,ii),ii=1,6),i5,pop(2),(Xmed(2,ii),ii=1,6)

c  check to see if rural:
	if(ierr1.eq.0)then
	  icc=i2+1000*i1
	 do is=1,idctotal
	 if(icc.eq.idc(is))go to 123
	 end do
 123	continue	
	 if(UR(is).ne.'U')goto 124
	end if
c end rural check


	istate=i1
	icounty=i2
	inum=1
	xpopcounty(1)=0.0
	xpopcounty(2)=0.0
		do while (ierr1.eq.0)


C	Check State/County:

	if (istate.eq.i1)then  ! revised just for state
	 
	 do i=1,2
	  do ii=1,6
	   xmedcounty(inum,i,ii)=xmed(i,ii)
	  end do ! ii do
		popt(inum,i)=pop(i)
		xpopcounty(i)=xpopcounty(i)+pop(i)
	 end do ! i do

	else ! we hit a new county
		do iii=1,2
		do j=1,inum-1
		  x(j)=xmedcounty(j,iii,6)*10000.
	    end do ! j do
      	call SORTRX(inum-1,x,INDEXx)
c	write (iwri1,111)indexx
c 111	format(30(I3))

c	find median 95th,90th, 75th,25th, 10th, 5th percentiles:
		
		aleft=mod(inum*1.0,2.0)
		do ic=1,6
		if(aleft.eq.0.0)then
			imid=inum/2.
			county(ic,iii)= xmedcounty(indexx(imid),iii,ic)
			else	
			 imid=(inum-1)/2.
			 county(ic,iii)=(xmedcounty(indexx(imid),iii,ic)+
	1		 xmedcounty(indexx(imid+1),iii,ic))/2.0
		end if ! aleft if

c population average conc:
			sum=0.0
		do ip=1,inum-1
			sum=xmedcounty(ip,iii,ic)*popt(ip,iii)+sum
		end do
		countya(ic,iii)=sum/xpopcounty(iii)
		
		
c	get 95th percentile:
		value=(0.95*(inum-1))+0.05
		ivalue=value
		value=value-ivalue
		county95(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 90th percentile:
		value=(0.90*(inum-1))+0.10
		ivalue=value
		value=value-ivalue
		county90(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 75th percentile:
		value=(0.75*(inum-1))+0.25
		ivalue=value
		value=value-ivalue
		county75(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 25th percentile:
		value=(0.25*(inum-1))+0.75
		ivalue=value
		value=value-ivalue
		county25(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 10th percentile:
		value=(0.10*(inum-1))+0.90
		ivalue=value
		value=value-ivalue
		county10(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))


c	get 5th percentile:
		value=(0.05*(inum-1))+0.95
		ivalue=value
		value=value-ivalue
		county5(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))


		end do !ic do


		end do !III do

	   icc=icounty+1000*istate
	do is=1,idctotal
	 if(icc.eq.idc(is))go to 777
	end do
 

c 777 	write(iwri1, 1000)polname(1:24),cas(1:9),istate,
c     1       statename(istate)(1:20),icounty,
c     1       countyname(is)(1:20),UR(is)(1:1),inum-1,xpopcounty(1),
c	1       (county(ic,1),ic=1,6),(county25(ic,1),ic=1,6),
c	2	   (county75(ic,1),ic=1,6),	xpopcounty(2),
c     3       (county(ic,2),ic=1,6),(county25(ic,2),ic=1,6),
c     4       (county75(ic,2),ic=1,6)

c 1000	format(2x,1a24,2x,1a9,2x,i2.2,2x,1a20,2x,i3.3,2x,
c     1          1a20,2x,1a1,2x,i3.3,2x,F9.0,18(2x,1pe11.3),
c     1           2x,0pF9.0,18(2x,1pe11.3))

c Modified output just for speadsheet format:
 777 	write(iwri1, 1000)statename(istate)(1:20),
     1                 "State Urban Counties",
	1                  istate*1000+.2,"U",
     1       county5(6,1),county10(6,1),county25(6,1),county(6,1),
	1	   countya(6,1),county75(6,1),county90(6,1),county95(6,1),
     1       (countya(ic,1),ic=1,5),
	1		     statename(istate)(1:20),
     1                 "State Urban Counties",
	1                  istate*1000,"U",
	1       county5(6,2),county10(6,2),county25(6,2),county(6,2),
	1	   countya(6,2),county75(6,2),county90(6,2),county95(6,2),
     1       (countya(ic,2),ic=1,5)


 1000	format(x,1a20,2x,1a20,2x,f7.1,2x,1a1,
	1            13(1pe11.3),2x,1a20,2x,1a20,2x,i5.5,2x,1a1,
	1            13(1pe11.3))







c	start the new county:
		
	istate=i1
	icounty=i2
	inum=1
	xpopcounty(1)=0.0
	xpopcounty(2)=0.0
		
		 do i=1,2
	  do ii=1,6
	   xmedcounty(inum,i,ii)=xmed(i,ii)
	  end do ! ii do
		popt(inum,i)=pop(i)	
		xpopcounty(i)=xpopcounty(i)+pop(i)
	 end do ! i do
	
c	source categories: point(1), area(2), onroad-mobile(3)	
c                        off-mobile(4), background(5), total(6)




	END IF !	State/County IF	


		inum=inum+1  ! add a tract

 125		READ (ird1, *,iostat=ierr1) i1,i2,i3,i4,pop(1),
	1   (Xmed(1,ii),ii=1,6),i5,pop(2),(Xmed(2,ii),ii=1,6)

c  check to see if rural:
	if(ierr1.eq.0)then
	  icc=i2+1000*i1
	 do is=1,idctotal
	  if(icc.eq.idc(is))go to 126
	 end do
 126	continue	
	 if(UR(is).ne.'U')goto 125
	end if
c end rural check
		end do ! ierr1 0

c	last county:
		do iii=1,2
		do j=1,inum-1
		  x(j)=xmedcounty(j,iii,6)*10000.
	    end do ! j do
      	call SORTRX(inum-1,x,INDEXx)
c	write (iwri1,111)indexx
c 111	format(30(I3))

c	find median 95th,90th, 75th,25th, 10th, 5th percentiles:
		
		aleft=mod(inum*1.0,2.0)
		do ic=1,6
		if(aleft.eq.0.0)then
			imid=inum/2.
			county(ic,iii)= xmedcounty(indexx(imid),iii,ic)
			else	
			 imid=(inum-1)/2.
			 county(ic,iii)=(xmedcounty(indexx(imid),iii,ic)+
	1		 xmedcounty(indexx(imid+1),iii,ic))/2.0
		end if ! aleft if

c population average conc:
			sum=0.0
		do ip=1,inum-1
			sum=xmedcounty(ip,iii,ic)*popt(ip,iii)+sum
		end do
		countya(ic,iii)=sum/xpopcounty(iii)
		

		
c	get 95th percentile:
		value=(0.95*(inum-1))+0.05
		ivalue=value
		value=value-ivalue
		county95(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 90th percentile:
		value=(0.90*(inum-1))+0.10
		ivalue=value
		value=value-ivalue
		county90(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 75th percentile:
		value=(0.75*(inum-1))+0.25
		ivalue=value
		value=value-ivalue
		county75(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 25th percentile:
		value=(0.25*(inum-1))+0.75
		ivalue=value
		value=value-ivalue
		county25(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

c	get 10th percentile:
		value=(0.10*(inum-1))+0.90
		ivalue=value
		value=value-ivalue
		county10(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))


c	get 5th percentile:
		value=(0.05*(inum-1))+0.95
		ivalue=value
		value=value-ivalue
		county5(ic,iii)=xmedcounty(indexx(ivalue),iii,ic)+
     1		 value*(xmedcounty(indexx(ivalue+1),iii,ic)-
	1		xmedcounty(indexx(ivalue),iii,ic))

		end do !ic do

		end do !III do

	do is=1,idctotal
	 icc=icounty+1000*istate
	if(icc.eq.idc(is))go to 888
	end do
888 	write(iwri1, 1000)statename(istate)(1:20),
     1                 "State Urban Counties",
	1                  istate*1000+.2,"U",
     1       county5(6,1),county10(6,1),county25(6,1),county(6,1),
	1	   countya(6,1),county75(6,1),county90(6,1),county95(6,1),
     1       (countya(ic,1),ic=1,5),
	1		     statename(istate)(1:20),
     1                 "State Urban Counties",
	1                  istate*1000,"U",
	1       county5(6,2),county10(6,2),county25(6,2),county(6,2),
	1	   countya(6,2),county75(6,2),county90(6,2),county95(6,2),
     1       (countya(ic,2),ic=1,5)


	STOP
	end	



C From Leonard J. Moss of SLAC:

C Here's a hybrid QuickSort I wrote a number of years ago.  It's
C based on suggestions in Knuth, Volume 3, and performs much better
C than a pure QuickSort on short or partially ordered input arrays.  


      SUBROUTINE SORTRX(N,DATA,INDEXX)
C===================================================================
C
C     SORTRX -- SORT, Real input, indeX output
C
C
C     Input:  N     INTEGER
C             DATA  REAL
C
C     Output: INDEXX INTEGER (DIMENSION N)
C
C This routine performs an in-memory sort of the first N elements of
C array DATA, returning into array INDEX the indices of elements of
C DATA arranged in ascending order.  Thus,
C
C    DATA(indexx(1)) will be the smallest number in array DATA;
C    DATA(indexx(N)) will be the largest number in DATA.
C
C The original data is not physically rearranged.  The original order
C of equal input values is not necessarily preserved.
C
C===================================================================
C
C SORTRX uses a hybrid QuickSort algorithm, based on several
C suggestions in Knuth, Volume 3, Section 5.2.2.  In particular, the
C "pivot key" [my term] for dividing each subsequence is chosen to be
C the median of the first, last, and middle values of the subsequence;
C and the QuickSort is cut off when a subsequence has 9 or fewer
C elements, and a straight insertion sort of the entire array is done
C at the end.  The result is comparable to a pure insertion sort for
C very short arrays, and very fast for very large arrays (of order 12
C micro-sec/element on the 3081K for arrays of 10K elements).  It is
C also not subject to the poor performance of the pure QuickSort on
C partially ordered data.
C
C Created:  15 Jul 1986  Len Moss
C
C===================================================================
 
      INTEGER   N,indexx(N)
      REAL      DATA(N)
 
      INTEGER   LSTK(31),RSTK(31),ISTK
      INTEGER   L,R,I,J,P,INDEXP,INDEXT
      REAL      DATAP
 
C     QuickSort Cutoff
C
C     Quit QuickSort-ing when a subsequence contains M or fewer
C     elements and finish off at end with straight insertion sort.
C     According to Knuth, V.3, the optimum value of M is around 9.
 
      INTEGER   M
      PARAMETER (M=9)
 
C===================================================================
C
C     Make initial guess for INDEXX
 
      DO 50 I=1,N
         indexx(I)=I
   50    CONTINUE
 
C     If array is short, skip QuickSort and go directly to
C     the straight insertion sort.
 
      IF (N.LE.M) GOTO 900
 
C===================================================================
C
C     QuickSort
C
C     The "Qn:"s correspond roughly to steps in Algorithm Q,
C     Knuth, V.3, PP.116-117, modified to select the median
C     of the first, last, and middle elements as the "pivot
C     key" (in Knuth's notation, "K").  Also modified to leave
C     data in place and produce an INDEX array.  To simplify
C     comments, let DATA[I]=DATA(indexx(I)).
 
C Q1: Initialize
      ISTK=0
      L=1
      R=N
 
  200 CONTINUE
 
C Q2: Sort the subsequence DATA[L]..DATA[R].
C
C     At this point, DATA[l] <= DATA[m] <= DATA[r] for all l < L,
C     r > R, and L <= m <= R.  (First time through, there is no
C     DATA for l < L or r > R.)
 
      I=L
      J=R
 
C Q2.5: Select pivot key
C
C     Let the pivot, P, be the midpoint of this subsequence,
C     P=(L+R)/2; then rearrange indexx(L), indexx(P), and indexx(R)
C     so the corresponding DATA values are in increasing order.
C     The pivot key, DATAP, is then DATA[P].
 
      P=(L+R)/2
      INDEXP=indexx(P)
      DATAP=DATA(INDEXP)
 
      IF (DATA(indexx(L)) .GT. DATAP) THEN
         indexx(P)=indexx(L)
         indexx(L)=INDEXP
         INDEXP=indexx(P)
         DATAP=DATA(INDEXP)
      ENDIF
 
      IF (DATAP .GT. DATA(indexx(R))) THEN
         IF (DATA(indexx(L)) .GT. DATA(indexx(R))) THEN
            indexx(P)=indexx(L)
            indexx(L)=indexx(R)
         ELSE
            indexx(P)=indexx(R)
         ENDIF
         indexx(R)=INDEXP
         INDEXP=indexx(P)
         DATAP=DATA(INDEXP)
      ENDIF
 
C     Now we swap values between the right and left sides and/or
C     move DATAP until all smaller values are on the left and all
C     larger values are on the right.  Neither the left or right
C     side will be internally ordered yet; however, DATAP will be
C     in its final position.
 
  300 CONTINUE
 
C Q3: Search for datum on left >= DATAP
C
C     At this point, DATA[L] <= DATAP.  We can therefore start scanning
C     up from L, looking for a value >= DATAP (this scan is guaranteed
C     to terminate since we initially placed DATAP near the middle of
C     the subsequence).
 
         I=I+1
         IF (DATA(indexx(I)).LT.DATAP) GOTO 300
 
  400 CONTINUE
 
C Q4: Search for datum on right <= DATAP
C
C     At this point, DATA[R] >= DATAP.  We can therefore start scanning
C     down from R, looking for a value <= DATAP (this scan is guaranteed
C     to terminate since we initially placed DATAP near the middle of
C     the subsequence).
 
         J=J-1
         IF (DATA(indexx(J)).GT.DATAP) GOTO 400
 
C Q5: Have the two scans collided?
 
      IF (I.LT.J) THEN
 
C Q6: No, interchange DATA[I] <--> DATA[J] and continue
 
         INDEXT=indexx(I)
         indexx(I)=indexx(J)
         indexx(J)=INDEXT
         GOTO 300
      ELSE
 
C Q7: Yes, select next subsequence to sort
C
C     At this point, I >= J and DATA[l] <= DATA[I] == DATAP <= DATA[r],
C     for all L <= l < I and J < r <= R.  If both subsequences are
C     more than M elements long, push the longer one on the stack and
C     go back to QuickSort the shorter; if only one is more than M
C     elements long, go back and QuickSort it; otherwise, pop a
C     subsequence off the stack and QuickSort it.
 
         IF (R-J .GE. I-L .AND. I-L .GT. M) THEN
            ISTK=ISTK+1
            LSTK(ISTK)=J+1
            RSTK(ISTK)=R
            R=I-1
         ELSE IF (I-L .GT. R-J .AND. R-J .GT. M) THEN
            ISTK=ISTK+1
            LSTK(ISTK)=L
            RSTK(ISTK)=I-1
            L=J+1
         ELSE IF (R-J .GT. M) THEN
            L=J+1
         ELSE IF (I-L .GT. M) THEN
            R=I-1
         ELSE
C Q8: Pop the stack, or terminate QuickSort if empty
            IF (ISTK.LT.1) GOTO 900
            L=LSTK(ISTK)
            R=RSTK(ISTK)
            ISTK=ISTK-1
         ENDIF
         GOTO 200
      ENDIF
 
  900 CONTINUE
 
C===================================================================
C
C Q9: Straight Insertion sort
 
      DO 950 I=2,N
         IF (DATA(indexx(I-1)) .GT. DATA(indexx(I))) THEN
            INDEXP=indexx(I)
            DATAP=DATA(INDEXP)
            P=I-1
  920       CONTINUE
               indexx(P+1) = indexx(P)
               P=P-1
               IF (P.GT.0) THEN
                  IF (DATA(indexx(P)).GT.DATAP) GOTO 920
               ENDIF
            indexx(P+1) = INDEXP
         ENDIF
  950    CONTINUE
 
C===================================================================
C
C     All done
 
      END